searchNodes=[{"type":"module","title":"RabbitMQStream","doc":"Responsible for managing multiple connections for a single cluster, routing requests accordingly, and enforcing Well-behaved praticies.","ref":"RabbitMQStream.html"},{"type":"module","title":"RabbitMQStream.Message.Buffer","doc":"","ref":"RabbitMQStream.Message.Buffer.html"},{"type":"function","title":"RabbitMQStream.Message.Buffer.all_commands/1","doc":"","ref":"RabbitMQStream.Message.Buffer.html#all_commands/1"},{"type":"function","title":"RabbitMQStream.Message.Buffer.incoming_data/2","doc":"Receives the binary, parses it into a command if possible, buffering when necessary.","ref":"RabbitMQStream.Message.Buffer.html#incoming_data/2"},{"type":"function","title":"RabbitMQStream.Message.Buffer.init/0","doc":"","ref":"RabbitMQStream.Message.Buffer.html#init/0"},{"type":"function","title":"RabbitMQStream.Message.Buffer.next_command/1","doc":"","ref":"RabbitMQStream.Message.Buffer.html#next_command/1"},{"type":"function","title":"RabbitMQStream.Message.Buffer.parse_frames/2","doc":"","ref":"RabbitMQStream.Message.Buffer.html#parse_frames/2"},{"type":"type","title":"RabbitMQStream.Message.Buffer.t/0","doc":"","ref":"RabbitMQStream.Message.Buffer.html#t:t/0"},{"type":"module","title":"RabbitMQStream.Message.Frame","doc":"","ref":"RabbitMQStream.Message.Frame.html"},{"type":"function","title":"RabbitMQStream.Message.Frame.atom_to_response_code/1","doc":"","ref":"RabbitMQStream.Message.Frame.html#atom_to_response_code/1"},{"type":"function","title":"RabbitMQStream.Message.Frame.code_to_command/1","doc":"","ref":"RabbitMQStream.Message.Frame.html#code_to_command/1"},{"type":"function","title":"RabbitMQStream.Message.Frame.command_to_code/1","doc":"","ref":"RabbitMQStream.Message.Frame.html#command_to_code/1"},{"type":"function","title":"RabbitMQStream.Message.Frame.response_code_to_atom/1","doc":"","ref":"RabbitMQStream.Message.Frame.html#response_code_to_atom/1"},{"type":"behaviour","title":"RabbitMQStream.Connection","doc":"Responsible for encoding and decoding messages, opening and maintaining a socket connection to a single node. It connects to the RabbitMQ, and authenticates, and mantains the connection open with heartbeats. Adding a connectiong to the supervision tree You can define a connection with: defmodule MyApp.MyConnection use RabbitMQStream.Connection end Then you can add it to your supervision tree: def start ( _ , _ ) do children = [ { MyApp.MyConnection , username : &quot;guest&quot; , password : &quot;guest&quot; , host : &quot;localhost&quot; , vhost : &quot;/&quot; } } , # ... ] opts = # ... Supervisor . start_link ( children , opts ) end Connection configuration The connection accept the following options: username - The username to use for authentication. Defaults to guest . password - The password to use for authentication. Defaults to guest . host - The host to connect to. Defaults to localhost . port - The port to connect to. Defaults to 5552 . vhost - The virtual host to use. Defaults to / . frame_max - The maximum frame size in Bytes. Defaults to 1_048_576 . heartbeat - The heartbeat interval in seconds. Defaults to 60 . lazy - If true , the connection won't starting until explicitly calling connect/1 . Defaults to false . Subscribing to messages You can subscribe to messages by calling subscribe/5 : { :ok , _subscription_id } = MyApp.MyConnection . subscribe ( &quot;stream-01&quot; , self ( ) , :next , 999 )","ref":"RabbitMQStream.Connection.html"},{"type":"callback","title":"RabbitMQStream.Connection.close/2","doc":"","ref":"RabbitMQStream.Connection.html#c:close/2"},{"type":"callback","title":"RabbitMQStream.Connection.connect/0","doc":"","ref":"RabbitMQStream.Connection.html#c:connect/0"},{"type":"callback","title":"RabbitMQStream.Connection.create_stream/2","doc":"","ref":"RabbitMQStream.Connection.html#c:create_stream/2"},{"type":"callback","title":"RabbitMQStream.Connection.declare_publisher/2","doc":"","ref":"RabbitMQStream.Connection.html#c:declare_publisher/2"},{"type":"callback","title":"RabbitMQStream.Connection.delete_publisher/1","doc":"","ref":"RabbitMQStream.Connection.html#c:delete_publisher/1"},{"type":"callback","title":"RabbitMQStream.Connection.delete_stream/1","doc":"","ref":"RabbitMQStream.Connection.html#c:delete_stream/1"},{"type":"callback","title":"RabbitMQStream.Connection.publish/3","doc":"","ref":"RabbitMQStream.Connection.html#c:publish/3"},{"type":"callback","title":"RabbitMQStream.Connection.query_metadata/1","doc":"","ref":"RabbitMQStream.Connection.html#c:query_metadata/1"},{"type":"callback","title":"RabbitMQStream.Connection.query_offset/2","doc":"","ref":"RabbitMQStream.Connection.html#c:query_offset/2"},{"type":"callback","title":"RabbitMQStream.Connection.query_publisher_sequence/2","doc":"","ref":"RabbitMQStream.Connection.html#c:query_publisher_sequence/2"},{"type":"callback","title":"RabbitMQStream.Connection.start_link/1","doc":"","ref":"RabbitMQStream.Connection.html#c:start_link/1"},{"type":"callback","title":"RabbitMQStream.Connection.store_offset/3","doc":"","ref":"RabbitMQStream.Connection.html#c:store_offset/3"},{"type":"callback","title":"RabbitMQStream.Connection.subscribe/5","doc":"","ref":"RabbitMQStream.Connection.html#c:subscribe/5"},{"type":"callback","title":"RabbitMQStream.Connection.unsubscribe/1","doc":"","ref":"RabbitMQStream.Connection.html#c:unsubscribe/1"},{"type":"type","title":"RabbitMQStream.Connection.connection_option/0","doc":"","ref":"RabbitMQStream.Connection.html#t:connection_option/0"},{"type":"type","title":"RabbitMQStream.Connection.connection_options/0","doc":"","ref":"RabbitMQStream.Connection.html#t:connection_options/0"},{"type":"type","title":"RabbitMQStream.Connection.offset/0","doc":"","ref":"RabbitMQStream.Connection.html#t:offset/0"},{"type":"type","title":"RabbitMQStream.Connection.t/0","doc":"","ref":"RabbitMQStream.Connection.html#t:t/0"},{"type":"module","title":"RabbitMQStream.Publisher","doc":"RabbitMQStream.Publisher allows you to define modules or processes that publish messages to a single stream. Defining a publisher Module A standalone publisher module can be defined with: defmodule MyApp.MyPublisher do use RabbitMQStream.Publisher , stream_name : &quot;my-stream&quot; , connection : MyApp.MyConnection end After adding it to your supervision tree, you can publish messages with: MyApp.MyPublisher . publish ( &quot;Hello, world!&quot; ) You can add the publisher to your supervision tree as follows this: def start ( _ , _ ) do children = [ # ... MyApp.MyPublisher ] opts = # ... Supervisor . start_link ( children , opts ) end The standalone publisher starts its own RabbitMQStream.Connection , declaring itself and fetching its most recent publishing_id , and declaring the stream, if it does not exist. Configuration The RabbitMQStream.Publisher accepts the following options: stream_name - The name of the stream to publish to. Required. reference_name - The string which is used by the server to prevent Duplicate Message . Defaults to __MODULE__.Publisher . connection - The identifier for a RabbitMQStream.Connection .","ref":"RabbitMQStream.Publisher.html"},{"type":"extras","title":"Getting Started","doc":"","ref":"getting-started.html"},{"type":"extras","title":"Getting Started - Installation","doc":"First add RabbitMQ to your mix.exs dependencies: def deps do [ { :rabbitmq_stream , &quot;~&gt; 0.2.0&quot; } , # ... ] end","ref":"getting-started.html#installation"},{"type":"extras","title":"Getting Started - Subscribing to stream","doc":"First you define a connection defmodule MyApp.MyConnection use RabbitMQStream.Connection end Then you can subscribe to messages from a stream: { :ok , _subscription_id } = MyApp.MyConnection . subscribe ( &quot;stream-01&quot; , self ( ) , :next , 999 )","ref":"getting-started.html#subscribing-to-stream"},{"type":"extras","title":"Getting Started - Publishing to stream","doc":"RabbitMQ Streams protocol needs a static :reference_name per publisher. This is used to prevent message duplication. For this reason, each stream needs, for now, a static module to publish messages, which keeps track of its own publishing_id . You can define a Publisher module like this: defmodule MyApp.MyPublisher use RabbitMQStream.Publisher , stream : &quot;stream-01&quot; , connection : MyApp.MyConnection end Then you can publish messages to the stream: MyApp.MyPublisher . publish ( &quot;Hello World&quot; )","ref":"getting-started.html#publishing-to-stream"},{"type":"extras","title":"Publishing Messages","doc":"Under construction","ref":"publishing.html"},{"type":"extras","title":"Using Connection","doc":"Under construction","ref":"connection.html"},{"type":"extras","title":"Changelog","doc":"","ref":"changelog.html"},{"type":"extras","title":"Changelog - 0.1.0","doc":"Initial release with the following features: Opening connection to RabbitMQ server Declaring a Stream Creating a Stream Publisher Subscribing to Stream Messages Initial Hex Release","ref":"changelog.html#0-1-0"},{"type":"extras","title":"Changelog - 0.2.0","doc":"The main objective of this release is to remove the manually added code from rabbitmq_stream_common 's Erlang implementation of Encoding and Decoding logic, with frame buffering.","ref":"changelog.html#0-2-0"}]